/**
 *System Security App
 * There are different ways implementing an App
 */
var systemsecurityApp = systemsecurityApp || {};  //Define App namespace, if you want.
/**
 * Constructor UNAS App
 */
systemsecurityApp.App = function () {
    this.id = 'System Security';
    this.name = 'System Security';
    this.version = '6.0.8';
    this.active = false;
    this.menuIcon = '/apps/systemsecurity/images/logo.png?v=6.0.8&';
    this.shortcutIcon = '/apps/systemsecurity/images/logo.png?v=6.0.8&';
    this.entryUrl = '/apps/systemsecurity/systemsecurity.html?v=6.0.8&';
    var self = this;
    this.systemsecurityAppWindow = function () { //create app window
        if(UNAS.CheckAppState('System Security')){
            return false;
        }
        self.window=new MUI.Window({
            id: 'systemsecurityAppWindow',
            title: UNAS._('System Security'),
            icon: '/apps/systemsecurity/images/logo_small.png?v=6.0.8&',
            width: 820,
            height: 550,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [720, 2000], 'y': [450, 1500] },
            loadMethod: 'xhr',
            contentURL: '/apps/systemsecurity/systemsecurity.html?v=6.0.8&',
            require: {  css: ['/apps/systemsecurity/css/systemsecurity.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("System Security",'systemsecurityAppWindow')}
        });
    };
    this.systemsecurityAppUninstall = function (){
        UNAS.RemoveDesktopShortcut('System Security');
        UNAS.RemoveMenu('System Security');
        UNAS.RemoveAppFromGroups('System Security', 'ControlPanel');
        //UNAS.RemoveAppFromGroups('System Security', 'Help');
        UNAS.RemoveAppFromApps('System Security');
    }
    new UNAS.Menu('UNAS_ControlPanel_Setting_Menu', this.name, this.menuIcon, 'System Security', '', this.systemsecurityAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'System Security', this.systemsecurityAppWindow);
    new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Setting', 'Location' : 14, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('System Security', UNAS._('System Security')); //translate menu
        UNAS.SetShortcutTitle('System Security', UNAS._('System Security')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('systemsecurityAppWindow', UNAS._('System Security'));
        }
    }
    UNAS.LoadTranslation('/apps/systemsecurity/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.systemsecurityAppWindow,this.systemsecurityAppUninstall);
};

new systemsecurityApp.App(); //Create app
