var ENABLED = 1;
var DISABLED = 0;
var init_config = null;
var white_list = null;
var black_list = null;
var firewall_list = null;
var LOGIN_WHITE_LIST = 1;
var LOGIN_BLACK_LIST = 0;

var get_status_try_again = false;

function init_page() {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");
  jQuery.ajax({
    url: "/apps/systemsecurity/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: "application/json",
    timeout: 30000,
    data: JSON.stringify({
      cmd: "systemsecurity_get_status",
      token: UToken
    }),
    success: function(data) {
      if (data.err == 0) {
        var config = data.results;
        init_config = config;
        set_login_disable_status(config.login);
        black_list = config.login.list.black;
        white_list = config.login.list.white;
        show_list();

        jQuery('#systemsecurity_manager_ddos_protection').prop('checked', config.ddos.status == ENABLED);
        firewall_list = config.firewall.list;
        show_firewall();
      }
      jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
      jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      if (get_status_try_again == false) {
        get_status_try_again = true;
        //await sleep(1000);
        init_page();
        get_status_try_again = false;
      } else {
        alert(textStatus);
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    }
  });
}


function set_login_disable_status(config) {
  if (config.PROTECT_TIMEOUT.ENABLED == ENABLED) {
    jQuery('#systemsecurity_manager_protect_timeout').prop('checked', true);
    jQuery('#systemsecurity_manager_protect_timeout').attr('status', 'enable');
    jQuery('#systemsecurity_manager_protect_timeout_time').attr('disabled', false);
  } else {
    jQuery('#systemsecurity_manager_protect_timeout').prop('checked', false);
    jQuery('#systemsecurity_manager_protect_timeout').attr('status', 'disable');
    jQuery('#systemsecurity_manager_protect_timeout_time').attr('disabled', true);
  }
  jQuery('#systemsecurity_manager_protect_threshold').val(config.FAILURE.THRESHOLD);
  jQuery('#systemsecurity_manager_protect_window').val(config.FAILURE.WINDOW);
  jQuery('#systemsecurity_manager_protect_timeout_time').val(config.PROTECT_TIMEOUT.TIMEOUT);
  if (config.LOGIN_PROTECT == ENABLED) {
    jQuery('#systemsecurity_manager_login_protect').prop('checked', true);
    jQuery('#systemsecurity_manager_login_protect').attr('status', 'enable');
    jQuery('#systemsecurity_manager_protect_timeout').attr('disabled', false);
    jQuery('#systemsecurity_manager_protect_threshold').attr('disabled', false);
    jQuery('#systemsecurity_manager_protect_window').attr('disabled', false);
  } else {
    jQuery('#systemsecurity_manager_login_protect').prop('checked', false);
    jQuery('#systemsecurity_manager_login_protect').attr('status', 'disable');
    jQuery('#systemsecurity_manager_protect_timeout').attr('disabled', true);
    jQuery('#systemsecurity_manager_protect_threshold').attr('disabled', true);
    jQuery('#systemsecurity_manager_protect_window').attr('disabled', true);
    jQuery('#systemsecurity_manager_protect_timeout_time').attr('disabled', true);
  }
  jQuery('#systemsecurity_manager_login_apply_btn').attr('class', 'unas_button_disabled systemsecurity_apply_btn');
  jQuery('#systemsecurity_manager_login_apply_btn').attr('onclick', 'javascript:void(0);');
  for (var item in config) {
    if (!isObjectValueEqual(config[item], init_config['login'][item])) {
      jQuery('#systemsecurity_manager_login_apply_btn').attr('class', 'unas_button systemsecurity_apply_btn');
      jQuery('#systemsecurity_manager_login_apply_btn').attr('onclick', 'submit_setting();');
      break;
    }
  }
}

function set_ddos_disable_status() {
  if (jQuery('#systemsecurity_manager_ddos_protection').prop('checked') ? ENABLED : DISABLED != init_config['ddos']['status']) {
    jQuery('#systemsecurity_ddos_apply_btn').attr('class', 'unas_button systemsecurity_apply_btn');
    jQuery('#systemsecurity_ddos_apply_btn').attr('onclick', 'ddos_apply();');
  } else {
    jQuery('#systemsecurity_ddos_apply_btn').attr('class', 'unas_button_disabled systemsecurity_apply_btn');
    jQuery('#systemsecurity_ddos_apply_btn').attr('onclick', 'javascript:void(0);');
  }
}

function isObjectValueEqual(a, b) {
  if (a == b) return true;
  if (typeof(a) != 'object') return false;
  var aProps = Object.getOwnPropertyNames(a);
  var bProps = Object.getOwnPropertyNames(b);
  if (aProps.length != bProps.length) {
    return false;
  }
  for (var i = 0; i < aProps.length; i++) {
    var propName = aProps[i];

    var propA = a[propName];
    var propB = b[propName];
    if (!b.hasOwnProperty(propName)) return false;
    if ((propA instanceof Object)) {
      if (isObjectValueEqual(propA, propB)) {} else {
        return false;
      }
    } else if (propA !== propB) {
      return false;
    }
  }
  return true;
}

function check_setting() {
  var new_config = {
    LOGIN_PROTECT: jQuery('#systemsecurity_manager_login_protect').prop('checked') ? ENABLED : DISABLED,
    FAILURE: {
      THRESHOLD: Number(jQuery('#systemsecurity_manager_protect_threshold').val()),
      WINDOW: Number(jQuery('#systemsecurity_manager_protect_window').val())
    },
    PROTECT_TIMEOUT: {
      ENABLED: jQuery('#systemsecurity_manager_protect_timeout').prop('checked') ? ENABLED : DISABLED,
      TIMEOUT: Number(jQuery('#systemsecurity_manager_protect_timeout_time').val())
    }
  }
  set_login_disable_status(new_config);
}

function one_list_item(rule, type, num, auto) {
  var checkbox_id = 'systemsecurity_list_' + String(type) + '_' + String(num);
  var tr_class = 'systemsecurity_list_' + String(type == LOGIN_BLACK_LIST ? 'black' : 'white');
  var str = '\
    <tr class="' + tr_class + '">\
      <td width="5%" align="center">\
        <span class="unas_table_text">\
          <div class="unas_checkbox">\
            <input type="checkbox" class="' + tr_class + '_checkbox" id="' + checkbox_id + '" list_num=' + String(num) + '>\
            <label for="' + checkbox_id + '"></label>\
          </div>\
        </span>\
      </td>\
      <td width="45%" align="left">\
        <span class="unas_table_text">' + rule + '</span>\
      </td>\
      <td width="20%" align="center">\
        <span class="unas_table_text">##$@systemsecurity@$##' + String(type == LOGIN_BLACK_LIST ? (auto == ENABLED ? 'Block(auto)' : 'Block') : 'Allow') + '##$@systemsecurity@$##</span>\
      </td>\
      <td width="30%" align="center">\
        <span class="unas_table_text">\
          <a class="unas_icon_delete" title="##$@systemsecurity@$##Delete##$@systemsecurity@$##" onclick="rm_rule(' + String(type) + ',' + String(num) + ');"></a>\
        </span>\
      </td>\
    </tr>';
  return str;
}

function one_firewall_item(rule, num) {
  var checkbox_id = 'systemsecurity_list_firewall_' + String(num);
  var str = '\
    <tr class="systemsecurity_list_firewall">\
      <td width="5%" align="center">\
        <span class="unas_table_text">\
          <div class="unas_checkbox">\
            <input type="checkbox" class="systemsecurity_list_firewall_checkbox" id="' + checkbox_id + '" list_num=' + String(num) + '>\
            <label for="' + checkbox_id + '"></label>\
          </div>\
        </span>\
      </td>\
      <td width="65%" align="left">\
        <span class="unas_table_text">' + rule + '</span>\
      </td>\
      <td width="30%" align="center">\
        <span class="unas_table_text">\
          <a class="unas_icon_edit" title="##$@systemsecurity@$##Edit##$@systemsecurity@$##" onclick="edit_firewall_window(' + String(num) + ');"></a>\
          <a class="unas_icon_delete" title="##$@systemsecurity@$##Delete##$@systemsecurity@$##" onclick="rm_firewall(' + String(num) + ');"></a>\
        </span>\
      </td>\
    </tr>';
  return str;
}

function show_list() {
  jQuery('#systemsecurity_list_table').empty();
  for (var i = 0; i < black_list.length; i++) {
    jQuery('#systemsecurity_list_table').append(one_list_item(black_list[i].rule, LOGIN_BLACK_LIST, i, black_list[i].auto));
  }
  for (var i = 0; i < white_list.length; i++) {
    jQuery('#systemsecurity_list_table').append(one_list_item(white_list[i].rule, LOGIN_WHITE_LIST, i, white_list[i].auto));
  }
  set_show_list();
  sysTranslator('systemsecurity_list_table');
}

function show_firewall() {
  jQuery('#systemsecurity_list_firewall_table').empty();
  for (var i = 0; i < firewall_list.length; i++) {
    jQuery('#systemsecurity_list_firewall_table').append(one_firewall_item(firewall_list[i].name, i));
  }
  set_show_firewall();
}

function set_show_list() {
  jQuery('#systemsecurity_list_select_all').prop('checked', false);
  jQuery('.systemsecurity_list_black_checkbox').prop('checked', false);
  jQuery('.systemsecurity_list_white_checkbox').prop('checked', false);
  jQuery('#systemsecurity_list_rm').attr("class", "unas_button_content_disabled");
  jQuery('#systemsecurity_list_rm').attr("onclick", "javascript:void(0)");
  var list_type = Number(jQuery('#systemsecurity_select_list option:selected').val());
  if (list_type == LOGIN_BLACK_LIST) {
    jQuery('.systemsecurity_list_black').attr("style", "display:inline-table");
    jQuery('.systemsecurity_list_white').attr("style", "display:none");
  } else if (list_type == LOGIN_WHITE_LIST) {
    jQuery('.systemsecurity_list_black').attr("style", "display:none");
    jQuery('.systemsecurity_list_white').attr("style", "display:inline-table");
  }
}

function set_show_firewall() {
  jQuery('#systemsecurity_list_firewall_select_all').prop('checked', false);
  jQuery('.systemsecurity_list_firewall_checkbox').prop('checked', false);
  jQuery('#systemsecurity_list_firewall_rm').attr("class", "unas_button_content_disabled");
  jQuery('#systemsecurity_list_firewall_rm').attr("onclick", "javascript:void(0)");
}

function submit_setting() {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");

  var data = {
    cmd: "systemsecurity_setting",
    token: UToken,
    params: {
      LOGIN_PROTECT: jQuery('#systemsecurity_manager_login_protect').prop('checked') ? ENABLED : DISABLED,
      FAILURE: {
        THRESHOLD: Number(jQuery('#systemsecurity_manager_protect_threshold').val()),
        WINDOW: Number(jQuery('#systemsecurity_manager_protect_window').val())
      },
      PROTECT_TIMEOUT: {
        ENABLED: jQuery('#systemsecurity_manager_protect_timeout').prop('checked') ? ENABLED : DISABLED,
        TIMEOUT: Number(jQuery('#systemsecurity_manager_protect_timeout_time').val())
      }
    }
  };

  jQuery.ajax({
    url: "/apps/systemsecurity/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: "application/json",
    timeout: 30000,
    data: JSON.stringify(data),
    success: function(data) {
      if (data.err != 0) {
        // failed
      }
      init_page();
      jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
      jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
      jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
    }
  });
}

function ddos_apply() {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");

  var data = {
    cmd: "systemsecurity_ddos_setting",
    token: UToken,
    params: {
      status: jQuery('#systemsecurity_manager_ddos_protection').prop('checked') ? ENABLED : DISABLED
    }
  };

  jQuery.ajax({
    url: "/apps/systemsecurity/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: "application/json",
    timeout: 30000,
    data: JSON.stringify(data),
    success: function(data) {
      if (data.err != 0) {
        // failed
      }
      init_page();
      jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
      jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
      jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
    }
  });
}

var rm_try_again = false;

function rm_rule(type, rule_id, force = DISABLED, refresh = true) {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");
  var rule = type == LOGIN_BLACK_LIST ? black_list[rule_id].rule : white_list[rule_id].rule;
  var data = {
    cmd: "systemsecurity_rule",
    token: UToken,
    params: {
      rule: rule,
      action: DISABLED,
      type: type,
      force: ENABLED //force
    }
  };

  jQuery.ajax({
    url: "/apps/systemsecurity/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: "application/json",
    timeout: 30000,
    data: JSON.stringify(data),
    success: function(result) {
      if (refresh) {
        init_page();
      } else {
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      if (rm_try_again == false) {
        rm_try_again = true;
        //await sleep(1000);
        rm_rule(type, rule_id, force, refresh);
        rm_try_again = false;
      } else {
        alert(textStatus);
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    }
  });
}

function rm_rules() {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");
  var rule_list = [];
  var list_type = Number(jQuery('#systemsecurity_select_list option:selected').val());
  if (list_type == LOGIN_BLACK_LIST) {
    jQuery('.systemsecurity_list_black_checkbox').each(function() {
      if (jQuery(this).prop('checked')) {
        rule_list.push(black_list[jQuery(this).attr('list_num')].rule);
      }
    });
  } else {
    jQuery('.systemsecurity_list_white_checkbox').each(function() {
      if (jQuery(this).prop('checked')) {
        rule_list.push(white_list[jQuery(this).attr('list_num')].rule);
      }
    });
  }
  if (rule_list.length) {
    var data = {
      cmd: "systemsecurity_rm_rules",
      token: UToken,
      params: {
        rules: rule_list,
        type: list_type
      }
    };
    jQuery.ajax({
      url: "/apps/systemsecurity/includes/index.php",
      type: "POST",
      async: true,
      dataType: "json",
      contentType: "application/json",
      timeout: 30000,
      data: JSON.encode(data),
      success: function(result) {
        init_page();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    });
  } else {
    jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
    jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
  }
}

var rm_firewall_try_again = false;

function rm_firewall(rule_id, force = DISABLED, refresh = true) {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");
  var name = firewall_list[rule_id].name;
  var data = {
    cmd: "systemsecurity_firewall",
    token: UToken,
    params: {
      name: name,
      action: DISABLED,
      force: ENABLED //force
    }
  };

  jQuery.ajax({
    url: "/apps/systemsecurity/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: "application/json",
    timeout: 30000,
    data: JSON.stringify(data),
    success: function(result) {
      if (refresh) {
        init_page();
      } else {
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      if (rm_firewall_try_again == false) {
        rm_firewall_try_again = true;
        //await sleep(1000);
        rm_firewall(rule_id, force, refresh);
        rm_firewall_try_again = false;
      } else {
        alert(textStatus);
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    }
  });
}

function rm_firewall_rules() {
  jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:block");
  jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:block");
  var firewall_rm_list = [];
  jQuery('.systemsecurity_list_firewall_checkbox').each(function() {
    if (jQuery(this).prop('checked')) {
      firewall_rm_list.push(firewall_list[jQuery(this).attr('list_num')].name);
    }
  });
  if (firewall_rm_list.length) {
    var data = {
      cmd: "systemsecurity_firewall_rm",
      token: UToken,
      params: {
        firewall: firewall_rm_list
      }
    };
    jQuery.ajax({
      url: "/apps/systemsecurity/includes/index.php",
      type: "POST",
      async: true,
      dataType: "json",
      contentType: "application/json",
      timeout: 30000,
      data: JSON.encode(data),
      success: function(result) {
        init_page();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
        jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
      }
    });
  } else {
    jQuery('#systemsecurity_manager_waiting_content').attr("style", "display:none");
    jQuery('#systemsecurity_manager_waiting_logo').attr("style", "display:none");
  }
}

function add_rule_window() {
  var cwh = getClientWH();
  var AddRuleW = new MUI.Modal({
    id: 'AddRuleWindow',
    title: UNAS._('##$@systemsecurity@$##Add Rule##$@systemsecurity@$##'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.9),
    height: 222,
    addClass: 'delete-modal',
    contentURL: '/apps/systemsecurity/m/add_rule.html?v=6.0.8&'
  });
}

function add_firewall_window() {
  var cwh = getClientWH();
  var AddFirewallW = new MUI.Modal({
    id: 'AddFirewallWindow',
    title: UNAS._('##$@systemsecurity@$##Add Firewall##$@systemsecurity@$##'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.9),
    height: parseInt(cwh.h * 0.7),
    addClass: 'delete-modal',
    contentURL: '/apps/systemsecurity/m/add_firewall.html?v=6.0.8&'
  });
}

var edited_firewall = null;

function edit_firewall_window(rule_id) {
  var cwh = getClientWH();
  edited_firewall = firewall_list[rule_id];
  var EditFirewallW = new MUI.Modal({
    id: 'EditFirewallWindow',
    title: UNAS._('##$@systemsecurity@$##Edit Firewall##$@systemsecurity@$##'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.9),
    height: parseInt(cwh.h * 0.7),
    addClass: 'delete-modal',
    contentURL: '/apps/systemsecurity/m/edit_firewall.html?v=6.0.8&'
  });
}

(function() {
  init_page();

  jQuery('div[systemsecurityitemtableid]').click(function() {
    var id = jQuery(this).attr('systemsecurityitemtableid');
    jQuery(this).attr('class', 'unas_tab_sel').siblings().attr('class', 'unas_tab');

    jQuery('#systemsecurity_manager_login_page').attr('style', 'display:none');
    jQuery('#systemsecurity_manager_network_page').attr('style', 'display:none');
    jQuery('#passwordpolicypage').attr('style', 'display:none');
    jQuery('#' + id).attr('style', 'display:block');
  });

  jQuery('#systemsecurity_list_select_all').click(function() {
    var list_type = Number(jQuery('#systemsecurity_select_list option:selected').val());
    if (!jQuery('#systemsecurity_list_select_all').prop('checked')) {
      jQuery('.systemsecurity_list_black_checkbox').prop('checked', false);
      jQuery('.systemsecurity_list_white_checkbox').prop('checked', false);
    } else
    if (list_type == LOGIN_BLACK_LIST) {
      jQuery('.systemsecurity_list_black_checkbox').prop('checked', true);
      jQuery('.systemsecurity_list_white_checkbox').prop('checked', false);
    } else
    if (list_type == LOGIN_WHITE_LIST) {
      jQuery('.systemsecurity_list_black_checkbox').prop('checked', false);
      jQuery('.systemsecurity_list_white_checkbox').prop('checked', true);
    }
  });

  jQuery('#systemsecurity_list_firewall_select_all').click(function() {
    if (!jQuery('#systemsecurity_list_firewall_select_all').prop('checked')) {
      jQuery('.systemsecurity_list_firewall_checkbox').prop('checked', false);
    } else {
      jQuery('.systemsecurity_list_firewall_checkbox').prop('checked', true);
    }
  });

  jQuery('.systemsecurity_list_firewall_checkbox').each(
    jQuery(this).click(function() {
      jQuery('#systemsecurity_list_firewall_select_all').prop('checked', true);
      jQuery('#systemsecurity_list_firewall_rm').attr("class", "unas_button_content_disabled");
      jQuery('#systemsecurity_list_firewall_rm').attr("onclick", "javascript:void(0)");
      if (jQuery('.systemsecurity_list_firewall_checkbox').length > 0) {
        jQuery('.systemsecurity_list_firewall_checkbox').each(function() {
          if (jQuery(this).prop('checked')) {
            jQuery('#systemsecurity_list_firewall_rm').attr("class", "unas_button_content");
            jQuery('#systemsecurity_list_firewall_rm').attr("onclick", "rm_firewall_rules();");
          } else {
            jQuery('#systemsecurity_list_firewall_select_all').prop('checked', false);
          }
        });
      } else {
        jQuery('#systemsecurity_list_firewall_select_all').prop('checked', false);
      }
    })
  );

  jQuery('.systemsecurity_list_black_checkbox,.systemsecurity_list_white_checkbox').each(
    jQuery(this).click(function() {
      var list_type = Number(jQuery('#systemsecurity_select_list option:selected').val());
      jQuery('#systemsecurity_list_select_all').prop('checked', true);
      jQuery('#systemsecurity_list_rm').attr("class", "unas_button_content_disabled");
      jQuery('#systemsecurity_list_rm').attr("onclick", "javascript:void(0)");
      if (list_type == LOGIN_BLACK_LIST) {
        if (jQuery('.systemsecurity_list_black_checkbox').length > 0) {
          jQuery('.systemsecurity_list_black_checkbox').each(function() {
            if (jQuery(this).prop('checked')) {
              jQuery('#systemsecurity_list_rm').attr("class", "unas_button_content");
              jQuery('#systemsecurity_list_rm').attr("onclick", "rm_rules();");
            } else {
              jQuery('#systemsecurity_list_select_all').prop('checked', false);
            }
          });
        } else {
          jQuery('#systemsecurity_list_select_all').prop('checked', false);
        }
      } else {
        if (jQuery('.systemsecurity_list_white_checkbox').length > 0) {
          jQuery('.systemsecurity_list_white_checkbox').each(function() {
            if (jQuery(this).prop('checked')) {
              jQuery('#systemsecurity_list_rm').attr("class", "unas_button_content");
              jQuery('#systemsecurity_list_rm').attr("onclick", "rm_rules();");
            } else {
              jQuery('#systemsecurity_list_select_all').prop('checked', false);
            }
          });
        } else {
          jQuery('#systemsecurity_list_select_all').prop('checked', false);
        }
      }
    })
  );

  jQuery('#systemsecurity_manager_ddos_protection').change(function() {
    set_ddos_disable_status();
  });


})();
